/****************************************************************************
   Copyright (c) 1995, 1996, 1997  Intel Corporation.  All Rights Reserved.
****************************************************************************/

#ifndef INCLUDED_RDXAM_H
#define INCLUDED_RDXAM_H

#ifdef _USEAMINTERFACE  
#include <strmif.h>
#include <evcode.h>
#endif

#ifdef _USEMYFG
#include <strmif.h>
#include <evcode.h>
#endif

// Callback error codes
#define PLAY_COMPLETE                         0x01
#define PLAY_USERABORT                        0x02
// Operation aborted because of error
#define PLAY_ERRORABORT                       0x03


#ifdef __cplusplus
extern "C" {
#endif

	
// define filter graph object handle
typedef void*   HFG;
typedef HFG*    LPHFG;

// define filter graph video object handle
typedef void*      HFGVID;
typedef HFGVID*    LPHFGVID;

// define filter graph audio object handle
typedef void*		HFGAUD;
typedef HFGAUD*		LPHFGAUD;


#ifdef _RDXAM_
#define RDXAM_SYMBOL   DllExport
#undef _USEMYFG 
#else
#define RDXAM_SYMBOL   DllImport
#endif

#define APIFN   RDXAM_SYMBOL WINAPI

typedef enum tagPlayMode { PLAYMODE_ONCE=0, PLAYMODE_REPEAT  };

typedef enum tagFGINFO {FG_INFO_LENGTH, FG_INFO_SAMPLERATE, FG_INFO_WIDTH,
						FG_INFO_HEIGHT, FG_INFO_COLORDEPTH } FGINFO;

typedef enum tagState { STOPPED=1, PAUSED, PLAYING, UNDEFINED_STATE } FGSTATE;

typedef enum tagSourceType { SRC_FILE, SRC_FILTER, SRC_FILTERGRAPH, SRC_UNDEFINED } SRC_TYPE;






#ifdef  _USEMYFG
	extern  DINORVAL APIFN fgVideoCreate ( HFGVID  *phfgVid);
	extern	DINORVAL APIFN fgVideoDelete ( HFGVID  hfgVid);
	extern	DINORVAL APIFN fgvidAssociateRenderer (HFGVID hfgVid, 	IFilter *pRenderer);
	extern  DINORVAL APIFN fgvidGetVideoPalette (HFGVID hfgVid, LOGPALETTE *pPalette);
	extern	DINORVAL APIFN fgvidSetTransparencyColor(HFGVID hfgVid, int Color);
	extern	DINORVAL APIFN fgvidGetTransparencyColor(HFGVID hfgVid, int *Color);
	extern	DINORVAL APIFN fgvidClearTransparency(HFGVID hfgVid);
	DEFINE_GUID(CLSID_RDXVID, 
		0x25f47240, 0x8bcc, 0x11cf, 0x9c, 0xe4, 0x0, 0xaa, 0x0, 0x3c, 0x37, 0xfc);

#else


	#ifdef _RDXAM_
		extern	DINORVAL APIFN fgvidAssociateRenderer (HFGVID hfgVid, 	IFilter *pRenderer);
	#endif

	#ifdef _USEAMINTERFACE
		extern	DINORVAL APIFN fgGetFiltergraphManager (HFG hfg, IGraphBuilder **pFg);
		extern  DINORVAL APIFN fgAssociateFilterGraph  (HFG hFilterGraph, IGraphBuilder *pGraph, IFilter *pRDXSrc);
	#endif

	extern  DINORVAL APIFN fgVideoCreate ( HFGVID  *phfgVid);
	extern	DINORVAL APIFN fgVideoDelete ( HFGVID  hfgVid);
	extern	DINORVAL APIFN fgCreate (HFG *phfilterGraph );
	extern	DINORVAL APIFN fgCreateEx ( COLORTYPE mode, HFG *hFilterGraph);
	extern	DINORVAL APIFN fgDelete (HFG hfg);
	extern  DINORVAL APIFN fgAssociateFile (HFG hFilterGraph,  	PSTR pFileName);
	extern  DINORVAL APIFN fgAssociateFilter (HFG hFilterGraph, const GUID *pFilterGuid);
	extern  DINORVAL APIFN fgGetNumStreams(	HFG hFilterGraph,DWORD *pnumVideoStreams, DWORD *pnumAudioStreams);
	extern	DINORVAL APIFN fgPlay(HFG	hfg, WORD	mode, DWORD dwStart, DWORD dwStop);
	extern	DINORVAL APIFN fgPause ( HFG hfg);
	extern	DINORVAL APIFN fgResume ( HFG hfg);
	extern	DINORVAL APIFN fgStop ( HFG hfg);
	extern	DINORVAL APIFN fgGetState (HFG hfg,  void *pStatusInfo);
	extern	DINORVAL APIFN fgGetVidInfo (HFG hfg,  HFGVID hfgVid, FGINFO infoType, void *pInfo);
	extern	DINORVAL APIFN fgvidSetTransparencyColor(HFGVID hfgVid, int Color);
	extern	DINORVAL APIFN fgvidGetTransparencyColor(HFGVID hfgVid, int *Color);
	extern	DINORVAL APIFN fgvidClearTransparency(HFGVID hfgVid);
	extern	DINORVAL APIFN fgNotifyEvent(HFG hFilterGraph ,  void (*fp)(HFG fg, DWORD evCode));
	extern	DINORVAL APIFN fgCreate ( HFG *phfilterGraph );
	extern	DINORVAL APIFN fgDelete (HFG hfg);
	extern  DINORVAL APIFN fgSeek(HFG  hfilterGraph, LONG llTime);
	extern	DINORVAL APIFN fgGetPosition(HFG  hfilterGraph, LONG *llTime);
	extern	DINORVAL APIFN fgSetPlayRate (HFG hFilterGraph, double rate);
	extern	DINORVAL APIFN fgGetPlayRate (HFG hFilterGraph, double *rate);
	extern	DINORVAL APIFN fgSetAudioVolume(HFG hFilterGraph, long  lVolume);
	extern	DINORVAL APIFN fgGetAudioVolume(HFG hFilterGraph, long  *plVolume);
	extern	DINORVAL APIFN fgSetAudioBalance(HFG hFilterGraph, long  lBalance);
	extern	DINORVAL APIFN fgGetAudioBalance(HFG hFilterGraph, long  *plBalance);
	extern  DINORVAL APIFN fgvidGetVideoPalette (HFGVID hfgVid, LOGPALETTE *pPalette);
	extern  DINORVAL APIFN fgGetAudioObject(HFG hFilterGraph, DWORD  iAudioIndex, HFGAUD *hfgAud);
	extern  DINORVAL APIFN fgGetVideoObject(HFG hFilterGraph, DWORD  iVideoIndex, HFGVID *hfgVid);
	extern  DINORVAL APIFN fgUseSafetyPalette(HFG hFilterGraph, char flag, PALETTEENTRY *paletteEntries);
	extern  DINORVAL APIFN fgDisableAudio(HFG hFilterGraph);
	extern  DINORVAL APIFN fgVideoSetData(HFG hFilterGraph, HFGVID vidDest, DWORD iVideoIndex);
#endif


#ifdef __cplusplus
}
#endif

#endif


